var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var index_exports = {};
__export(index_exports, {
  default: () => index_default
});
module.exports = __toCommonJS(index_exports);

// src/handlers/search/index.ts
var import_sdk = __toESM(require("@searchkit/sdk"));

// src/handlers/SearchkitModule.ts
var SearchkitSDK = __toESM(require("@searchkit/sdk"));
var SearchkitModule_default = typeof SearchkitSDK.default === "object" ? SearchkitSDK.default : SearchkitSDK;

// src/version.ts
var LIB_VERSION = "1.23.0";

// src/handlers/search/Query.ts
var { CustomQuery } = SearchkitModule_default;
var EngineQuery = () => new CustomQuery({
  queryFn: (query) => {
    return {
      bool: {
        must: [
          {
            query_string: {
              query
            }
          }
        ]
      }
    };
  }
});

// src/handlers/search/Configuration.ts
var {
  Filter: SKFilter,
  GeoDistanceOptionsFacet,
  MultiQueryOptionsFacet,
  RefinementSelectFacet
} = SearchkitModule_default;
function getResultFields(resultFields) {
  const hitFields = Object.keys(resultFields);
  const highlightFields = Object.keys(resultFields).reduce((acc, fieldKey) => {
    const fieldConfiguration = resultFields[fieldKey];
    if (fieldConfiguration.snippet) {
      acc.push(fieldKey);
    }
    return acc;
  }, []);
  return { hitFields, highlightFields };
}
function isValidDateString(dateString) {
  return typeof dateString === "string" && !isNaN(Date.parse(dateString));
}
function isRangeFilter(filterValue) {
  return typeof filterValue === "object" && ("from" in filterValue || "to" in filterValue);
}
function buildBaseFilters(baseFilters) {
  const filters = (baseFilters || []).reduce((acc, filter) => {
    const boolType = {
      all: "filter",
      any: "should",
      none: "must_not"
    }[filter.type];
    return [
      ...acc,
      {
        bool: {
          [boolType]: filter.values.map((value) => {
            if (isRangeFilter(value)) {
              return {
                range: {
                  [filter.field]: __spreadValues(__spreadValues({}, "from" in value ? {
                    from: isValidDateString(value.from) ? value.from : Number(value.from)
                  } : {}), "to" in value ? {
                    to: isValidDateString(value.to) ? value.to : Number(value.to)
                  } : {})
                }
              };
            }
            return {
              term: {
                [filter.field]: value
              }
            };
          })
        }
      }
    ];
  }, []);
  return filters;
}
function buildConfiguration({
  state,
  queryConfig
}) {
  var _a;
  const { hitFields, highlightFields } = getResultFields(
    queryConfig.result_fields
  );
  const filtersConfig = Object.values(
    (state.filters || []).filter((f) => !queryConfig.facets[f.field]).reduce((acc, f) => {
      return __spreadProps(__spreadValues({}, acc), {
        [f.field]: new SKFilter({
          field: f.field,
          identifier: f.field,
          label: f.field
        })
      });
    }, {})
  );
  const facets = Object.keys(queryConfig.facets || {}).reduce(
    (acc, facetKey) => {
      var _a2;
      const facetConfiguration = queryConfig.facets[facetKey];
      const isDisJunctive = (_a2 = queryConfig.disjunctiveFacets) == null ? void 0 : _a2.includes(facetKey);
      if (facetConfiguration.type === "value") {
        acc.push(
          new RefinementSelectFacet({
            identifier: facetKey,
            field: facetKey,
            label: facetKey,
            size: facetConfiguration.size || 20,
            multipleSelect: isDisJunctive,
            order: facetConfiguration.sort || "count"
          })
        );
      } else if (facetConfiguration.type === "range" && !facetConfiguration.center) {
        acc.push(
          new MultiQueryOptionsFacet({
            identifier: facetKey,
            field: facetKey,
            label: facetKey,
            multipleSelect: isDisJunctive,
            options: facetConfiguration.ranges.map((range) => {
              return __spreadValues(__spreadValues(__spreadValues(__spreadValues({
                label: range.name
              }, typeof range.from === "number" ? { min: range.from } : {}), typeof range.to === "number" ? { max: range.to } : {}), isValidDateString(range.from) ? { dateMin: range.from.toString() } : {}), isValidDateString(range.to) ? { dateMax: range.to.toString() } : {});
            })
          })
        );
      } else if (facetConfiguration.type === "range" && facetConfiguration.center) {
        acc.push(
          new GeoDistanceOptionsFacet({
            identifier: facetKey,
            field: facetKey,
            label: facetKey,
            multipleSelect: isDisJunctive,
            origin: facetConfiguration.center,
            unit: facetConfiguration.unit,
            ranges: facetConfiguration.ranges.map((range) => {
              return __spreadValues(__spreadValues({
                label: range.name
              }, range.from ? { from: Number(range.from) } : {}), range.to ? { to: Number(range.to) } : {});
            })
          })
        );
      }
      return acc;
    },
    []
  );
  const sortOption = ((_a = state.sortList) == null ? void 0 : _a.length) > 0 ? {
    id: "selectedOption",
    label: "selectedOption",
    field: state.sortList.reduce((acc, s) => {
      acc.push({
        [s.field]: s.direction
      });
      return acc;
    }, [])
  } : { id: "selectedOption", label: "selectedOption", field: "_score" };
  const jsVersion = typeof window !== "undefined" ? "browser" : process.version;
  const metaHeader = `ent=${LIB_VERSION}-engines-connector,js=${jsVersion},t=${LIB_VERSION}-engines-connector,ft=universal`;
  const configuration = {
    // overriding the transport and providing the host, index and apiKey to the transport
    host: "host",
    index: "engineName",
    connectionOptions: {
      headers: {
        "x-elastic-client-meta": metaHeader
      }
    },
    hits: {
      fields: hitFields,
      highlightedFields: highlightFields
    },
    query: EngineQuery(),
    sortOptions: [sortOption],
    facets,
    filters: filtersConfig
  };
  return configuration;
}
var Configuration_default = buildConfiguration;

// src/handlers/search/Request.ts
var import_search_ui = require("@elastic/search-ui");
function getFilters(filters = [], baseFilters = []) {
  return filters.reduce((acc, f) => {
    const isBaseFilter = baseFilters.includes(f);
    if (isBaseFilter) return acc;
    const subFilters = f.values.map((v) => {
      if (import_search_ui.helpers.isFilterValueRange(v)) {
        return __spreadValues(__spreadValues({
          identifier: f.field
        }, isValidDateString(v.from) ? { dateMin: v.from } : { min: v.from }), isValidDateString(v.to) ? { dateMax: v.to } : { max: v.to });
      }
      return {
        identifier: f.field,
        value: v
      };
    });
    return [...acc, ...subFilters];
  }, []);
}
function SearchRequest(state, queryConfig) {
  var _a;
  return {
    query: state.searchTerm,
    filters: state.filters ? getFilters(state.filters, queryConfig.filters) : [],
    from: (state.current - 1) * state.resultsPerPage,
    size: state.resultsPerPage,
    sort: ((_a = state.sortList) == null ? void 0 : _a.length) > 0 ? "selectedOption" : null
  };
}
var Request_default = SearchRequest;

// src/handlers/common.ts
function fieldResponseMapper(item) {
  const fields = item.fields;
  const highlights = item.highlight || {};
  const combinedFieldKeys = [
    ...new Set(Object.keys(fields).concat(Object.keys(highlights)))
  ];
  return combinedFieldKeys.reduce(
    (acc, key) => {
      return __spreadProps(__spreadValues({}, acc), {
        [key]: __spreadValues(__spreadValues({}, fields[key] ? { raw: fields[key] } : {}), highlights[key] ? { snippet: highlights[key] } : {})
      });
    },
    {
      id: { raw: item.id },
      _meta: {
        id: item.rawHit._id,
        rawHit: item.rawHit
      }
    }
  );
}

// src/handlers/search/Response.ts
function SearchResponse(results) {
  const facets = (results.facets || []).reduce((acc, facet) => {
    return __spreadProps(__spreadValues({}, acc), {
      [facet.identifier]: [
        {
          data: facet.entries.map((e) => ({
            value: e.label,
            count: e.count
          })),
          type: "value"
        }
      ]
    });
  }, {});
  const pageEnd = (results.hits.page.pageNumber + 1) * results.hits.page.size;
  const response = {
    resultSearchTerm: results.summary.query,
    totalPages: results.hits.page.totalPages,
    pagingStart: results.summary.total && results.hits.page.pageNumber * results.hits.page.size + 1,
    pagingEnd: pageEnd > results.summary.total ? results.summary.total : pageEnd,
    wasSearched: false,
    totalResults: results.summary.total,
    facets,
    results: results.hits.items.map(fieldResponseMapper),
    requestId: null,
    rawResponse: null
  };
  return response;
}
var Response_default = SearchResponse;

// src/handlers/search/index.ts
var Searchkit = import_sdk.default.default || import_sdk.default;
function handleRequest(configuration) {
  return __async(this, null, function* () {
    const { state, queryConfig } = configuration;
    const searchkitConfig = Configuration_default({
      state,
      queryConfig
    });
    const request = Searchkit(searchkitConfig, configuration.transporter);
    const searchkitVariables = Request_default(state, queryConfig);
    const baseFilters = buildBaseFilters(queryConfig.filters);
    const results = yield request.query(searchkitVariables.query).setFilters(searchkitVariables.filters).setSortBy(searchkitVariables.sort).execute(
      {
        facets: queryConfig.facets && Object.keys(queryConfig.facets).length > 0,
        hits: {
          from: searchkitVariables.from,
          size: searchkitVariables.size,
          includeRawHit: true
        }
      },
      baseFilters
    );
    return Response_default(results);
  });
}

// src/handlers/autocomplete/index.ts
var {
  default: Searchkit2,
  CompletionSuggester,
  HitsSuggestor,
  PrefixQuery
} = SearchkitModule_default;
function handleRequest2(configuration) {
  return __async(this, null, function* () {
    const { state, queryConfig } = configuration;
    const suggestionConfigurations = [];
    if (queryConfig.results) {
      const { hitFields, highlightFields } = getResultFields(
        queryConfig.results.result_fields
      );
      suggestionConfigurations.push(
        new HitsSuggestor({
          identifier: "hits-suggestions",
          hits: {
            fields: hitFields,
            highlightedFields: highlightFields
          },
          query: new PrefixQuery({ fields: ["*"] }),
          size: queryConfig.results.resultsPerPage || 5
        })
      );
    }
    if (queryConfig.suggestions && queryConfig.suggestions.types) {
      const configs = Object.keys(queryConfig.suggestions.types).map((type) => {
        const configuration2 = queryConfig.suggestions.types[type];
        const suggestionsSize = queryConfig.suggestions.size || 5;
        if (configuration2.queryType === "results") {
          const { hitFields, highlightFields } = getResultFields(
            configuration2.result_fields
          );
          return new HitsSuggestor({
            identifier: `suggestions-hits-${type}`,
            index: configuration2.index,
            hits: {
              fields: hitFields,
              highlightedFields: highlightFields
            },
            query: new PrefixQuery({ fields: ["*"] }),
            size: suggestionsSize
          });
        } else if (!configuration2.queryType || configuration2.queryType === "suggestions") {
          const { fields } = configuration2;
          return new CompletionSuggester({
            identifier: `suggestions-completion-${type}`,
            field: fields[0],
            size: suggestionsSize
          });
        }
      });
      suggestionConfigurations.push(...configs);
    }
    const searchkitConfig = {
      host: "host",
      index: "engineName",
      suggestions: suggestionConfigurations
    };
    const response = yield Searchkit2(
      searchkitConfig,
      configuration.transporter
    ).executeSuggestions(state.searchTerm);
    const results = response.reduce(
      (acc, suggestion) => {
        const { identifier } = suggestion;
        if (identifier === "hits-suggestions") {
          return __spreadProps(__spreadValues({}, acc), {
            autocompletedResults: suggestion.hits.map(fieldResponseMapper)
          });
        } else if (identifier.startsWith("suggestions-completion-")) {
          const name = identifier.replace("suggestions-completion-", "");
          return __spreadProps(__spreadValues({}, acc), {
            autocompletedSuggestions: __spreadProps(__spreadValues({}, acc.autocompletedSuggestions), {
              [name]: suggestion.suggestions.map((suggestion2) => {
                return {
                  suggestion: suggestion2
                };
              })
            })
          });
        } else if (identifier.startsWith("suggestions-hits-")) {
          const name = identifier.replace("suggestions-hits-", "");
          const config = queryConfig.suggestions.types[name];
          return __spreadProps(__spreadValues({}, acc), {
            autocompletedSuggestions: __spreadProps(__spreadValues({}, acc.autocompletedSuggestions), {
              [name]: suggestion.hits.map((hit) => ({
                queryType: config.queryType,
                result: fieldResponseMapper(hit)
              }))
            })
          });
        }
      },
      {
        autocompletedSuggestions: {}
      }
    );
    return results;
  });
}

// src/handlers/transporter.ts
var EngineTransporter = class {
  constructor(host, engineName, apiKey) {
    this.host = host;
    this.engineName = engineName;
    this.apiKey = apiKey;
  }
  performRequest(requestBody) {
    return __async(this, null, function* () {
      if (!fetch)
        throw new Error("Fetch is not supported in this browser / environment");
      const response = yield fetch(
        `${this.host}/api/engines/${this.engineName}/_search`,
        {
          method: "POST",
          body: JSON.stringify(requestBody),
          headers: {
            "Content-Type": "application/json",
            Authorization: `ApiKey ${this.apiKey}`
          }
        }
      );
      const json = yield response.json();
      return json;
    });
  }
};

// src/index.ts
function isTransporter(config) {
  return config.performRequest !== void 0;
}
var EngineConnector = class {
  constructor(config) {
    this.config = config;
    if (isTransporter(config)) {
      this.transporter = config;
    } else {
      if (!config.host) {
        throw new Error("Engine Host must be provided.");
      }
      if (!config.engineName) {
        throw new Error("Engine Name must be provided.");
      }
      if (!config.apiKey) {
        throw new Error("API Key must be provided.");
      }
      const { host, engineName, apiKey } = config;
      this.transporter = new EngineTransporter(host, engineName, apiKey);
    }
  }
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  onResultClick() {
  }
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  onAutocompleteResultClick() {
  }
  onSearch(state, queryConfig) {
    return __async(this, null, function* () {
      return handleRequest({
        state,
        queryConfig,
        transporter: this.transporter
      });
    });
  }
  onAutocomplete(state, queryConfig) {
    return __async(this, null, function* () {
      return handleRequest2({
        state,
        queryConfig,
        transporter: this.transporter
      });
    });
  }
};
var index_default = EngineConnector;
//# sourceMappingURL=index.js.map